MsWrd1Parser Class Referencefinal

the main class to read a Microsoft Word 1 file More...

`#include <MsWrd1Parser.hxx>`

Inheritance diagram for MsWrd1Parser:

## Public Member Functions

| MsWrd1Parser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MsWrd1Parser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
void | sendMain ()
| try to send the main zone
void | newPage (int number)
| adds a new page
bool | createZones ()
| finds the different zones
bool | sendText (MWAWEntry const &entry, bool main=false)
| send the text structure to the listener
bool | readFont (long fPos, MsWrd1ParserInternal::Font &font)
| try to read a char property
bool | readParagraph (long fPos, MsWrd1ParserInternal::Paragraph &para)
| try to read a paragraph property
bool | readFootnoteCorrespondance (MWAWVec2i limit)
| try to read the footnote correspondance ( zone2 )
bool | readDocInfo (MWAWVec2i limit)
| try to read the document info (zone 3)
bool | readZones (MWAWVec2i limit)
| try to read the list of zones: separator between text and footnote?
bool | readPageBreak (MWAWVec2i limit)
| try to read the page break (zone 5)
bool | prepareTextZones ()
| prepare the data: separate header/footer zones to the main stream...
void | removeLastCharIfEOL (MWAWEntry &entry)
| shorten an entry if the last character is EOL
bool | readPLC (MWAWVec2i limits, int wh)
| read the two first zones (char and paragraph)
void | setProperty (MsWrd1ParserInternal::Paragraph const &para)
| send the ruler properties
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< MsWrd1ParserInternal::State > | m_state
| the state

## Friends

class | MsWrd1ParserInternal::SubDocument

## Detailed Description

the main class to read a Microsoft Word 1 file

## Constructor & Destructor Documentation

## MsWrd1Parser()

MsWrd1Parser::MsWrd1Parser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~MsWrd1Parser()

MsWrd1Parser::~MsWrd1Parser | ( |  | ) |

final

destructor

## Member Function Documentation

## checkHeader()

bool MsWrd1Parser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MsWrd1ParserInternal::SubDocument, and parse().

## createDocument()

void MsWrd1Parser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by MsWrd1ParserInternal::SubDocument, and parse().

## createZones()

bool MsWrd1Parser::createZones | ( |  | ) |

protected

finds the different zones

Referenced by MsWrd1ParserInternal::SubDocument, and parse().

## init()

void MsWrd1Parser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MsWrd1Parser(), and MsWrd1ParserInternal::SubDocument.

## newPage()

void MsWrd1Parser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by MsWrd1ParserInternal::SubDocument, and sendText().

## parse()

void MsWrd1Parser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

final virtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by MsWrd1ParserInternal::SubDocument.

## prepareTextZones()

bool MsWrd1Parser::prepareTextZones | ( |  | ) |

protected

prepare the data: separate header/footer zones to the main stream...

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## readDocInfo()

bool MsWrd1Parser::readDocInfo | ( | MWAWVec2i | limit | ) |

protected

try to read the document info (zone 3)

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## readFont()

bool MsWrd1Parser::readFont | ( | long | fPos,
|  | MsWrd1ParserInternal::Font & | font )

protected

try to read a char property

Referenced by MsWrd1ParserInternal::SubDocument, and readPLC().

## readFootnoteCorrespondance()

bool MsWrd1Parser::readFootnoteCorrespondance | ( | MWAWVec2i | limit | ) |

protected

try to read the footnote correspondance ( zone2 )

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## readPageBreak()

bool MsWrd1Parser::readPageBreak | ( | MWAWVec2i | limit | ) |

protected

try to read the page break (zone 5)

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## readParagraph()

bool MsWrd1Parser::readParagraph | ( | long | fPos,
|  | MsWrd1ParserInternal::Paragraph & | para )

protected

try to read a paragraph property

Referenced by MsWrd1ParserInternal::SubDocument, and readPLC().

## readPLC()

bool MsWrd1Parser::readPLC | ( | MWAWVec2i | limits,
|  | int | wh )

protected

read the two first zones (char and paragraph)

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## readZones()

bool MsWrd1Parser::readZones | ( | MWAWVec2i | limit | ) |

protected

try to read the list of zones: separator between text and footnote?

(zone 4)

Referenced by createZones(), and MsWrd1ParserInternal::SubDocument.

## removeLastCharIfEOL()

void MsWrd1Parser::removeLastCharIfEOL | ( | MWAWEntry & | entry | ) |

protected

shorten an entry if the last character is EOL

Referenced by createDocument(), MsWrd1ParserInternal::SubDocument, and sendText().

## sendMain()

void MsWrd1Parser::sendMain | ( |  | ) |

protected

try to send the main zone

Referenced by MsWrd1ParserInternal::SubDocument, and parse().

## sendText()

bool MsWrd1Parser::sendText | ( | MWAWEntry const & | entry,
|  | bool | main = false )

protected

send the text structure to the listener

Referenced by MsWrd1ParserInternal::SubDocument, and sendMain().

## setProperty()

void MsWrd1Parser::setProperty | ( | MsWrd1ParserInternal::Paragraph const & | para | ) |

protected

send the ruler properties

Referenced by MsWrd1ParserInternal::SubDocument, and sendText().

## Friends And Related Symbol Documentation

## MsWrd1ParserInternal::SubDocument

friend class MsWrd1ParserInternal::SubDocument

friend

## Member Data Documentation

## m_state

std::shared_ptr<MsWrd1ParserInternal::State> MsWrd1Parser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), MsWrd1Parser(), newPage(), prepareTextZones(), readDocInfo(), readFootnoteCorrespondance(), readPageBreak(), readPLC(), readZones(), sendMain(), and sendText().

The documentation for this class was generated from the following files:

- MsWrd1Parser.hxx
- MsWrd1Parser.cxx